var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import objectAssign from 'object-assign';
import PropTypes from 'prop-types';

import { getLensModeEnlargedImageCoordinates, getInPlaceEnlargedImageCoordinates } from './lib/imageCoordinates';
import ImageShape from './prop-types/ImageShape';
import { noop } from './utils';
import Point from './prop-types/Point';
import { ENLARGED_IMAGE_POSITION } from './constants';

var _class = function (_React$Component) {
    _inherits(_class, _React$Component);

    function _class(props) {
        _classCallCheck(this, _class);

        var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, props));

        _this.state = {
            isTransitionEntering: false,
            isTransitionActive: false,
            isTransitionLeaving: false,
            isTransitionDone: false
        };

        _this.timers = [];
        return _this;
    }

    _createClass(_class, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            this.scheduleCssTransition(nextProps);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.timers.forEach(function (timerId) {
                clearTimeout(timerId);
            });
        }
    }, {
        key: 'scheduleCssTransition',
        value: function scheduleCssTransition(nextProps) {
            var _this2 = this;

            var _props = this.props,
                fadeDurationInMs = _props.fadeDurationInMs,
                isActive = _props.isActive,
                isPositionOutside = _props.isPositionOutside;

            var willIsActiveChange = isActive !== nextProps.isActive;
            var willIsPositionOutsideChange = isPositionOutside !== nextProps.isPositionOutside;

            if (!willIsActiveChange && !willIsPositionOutsideChange) {
                return;
            }

            if (nextProps.isActive && !nextProps.isPositionOutside) {
                this.setState({
                    isTrainsitionDone: false,
                    isTransitionEntering: true
                });

                this.timers.push(setTimeout(function () {
                    _this2.setState({
                        isTransitionEntering: false,
                        isTransitionActive: true
                    });
                }, 0));
            } else {
                this.setState({
                    isTransitionLeaving: true,
                    isTransitionActive: false
                });

                this.timers.push(setTimeout(function () {
                    _this2.setState({
                        isTransitionDone: true,
                        isTransitionLeaving: false
                    });
                }, fadeDurationInMs));
            }
        }
    }, {
        key: 'getDefaultContainerStyle',
        value: function getDefaultContainerStyle() {
            var imagePosition = this.props.imagePosition;

            var baseContainerStyle = {
                position: 'absolute',
                top: '0px',
                overflow: 'hidden'
            };
            var OVER = ENLARGED_IMAGE_POSITION.over;

            var isInPlaceMode = imagePosition === OVER;

            if (isInPlaceMode) {
                return objectAssign(baseContainerStyle, {
                    left: '0px'
                });
            }

            return objectAssign(baseContainerStyle, {
                left: '100%',
                marginLeft: '10px',
                border: '1px solid #d6d6d6'
            });
        }
    }, {
        key: 'getImageCoordinates',
        value: function getImageCoordinates() {
            var _props2 = this.props,
                imagePosition = _props2.imagePosition,
                cursorOffset = _props2.cursorOffset,
                largeImage = _props2.largeImage,
                smallImage = _props2.smallImage,
                position = _props2.position;
            var OVER = ENLARGED_IMAGE_POSITION.over;

            var isInPlaceMode = imagePosition === OVER;

            if (isInPlaceMode) {
                return getInPlaceEnlargedImageCoordinates(smallImage, largeImage, position);
            }

            return getLensModeEnlargedImageCoordinates(smallImage, largeImage, position, cursorOffset);
        }
    }, {
        key: 'render',
        value: function render() {
            var _props3 = this.props,
                containerClassName = _props3.containerClassName,
                containerStyle = _props3.containerStyle,
                fadeDurationInMs = _props3.fadeDurationInMs,
                imageClassName = _props3.imageClassName,
                imageStyle = _props3.imageStyle,
                isLazyLoaded = _props3.isLazyLoaded,
                largeImage = _props3.largeImage,
                _props3$largeImage = _props3.largeImage,
                _props3$largeImage$on = _props3$largeImage.onLoad,
                onLoad = _props3$largeImage$on === undefined ? noop : _props3$largeImage$on,
                _props3$largeImage$on2 = _props3$largeImage.onError,
                onError = _props3$largeImage$on2 === undefined ? noop : _props3$largeImage$on2,
                smallImage = _props3.smallImage;
            var _state = this.state,
                isTransitionEntering = _state.isTransitionEntering,
                isTransitionActive = _state.isTransitionActive,
                isTransitionLeaving = _state.isTransitionLeaving;

            var isVisible = !!(isTransitionEntering || isTransitionActive || isTransitionLeaving);

            var defaultContainerStyle = this.getDefaultContainerStyle();
            var computedContainerStyle = {
                width: smallImage.width,
                height: smallImage.height,
                opacity: this.state.isTransitionActive ? 1 : 0,
                transition: 'opacity ' + fadeDurationInMs + 'ms ease-in',
                pointerEvents: 'none'
            };
            var compositeContainerStyle = objectAssign({}, defaultContainerStyle, containerStyle, computedContainerStyle);

            var imageCoordinates = this.getImageCoordinates();
            var translate = 'translate(' + imageCoordinates.x + 'px, ' + imageCoordinates.y + 'px)';
            var computedImageStyle = {
                width: largeImage.width,
                height: largeImage.height,
                transform: translate,
                WebkitTransform: translate,
                msTransform: translate,
                pointerEvents: 'none'
            };
            var compositeImageStyle = objectAssign({}, imageStyle, computedImageStyle);

            var component = React.createElement(
                'div',
                {
                    className: containerClassName,
                    style: compositeContainerStyle
                },
                React.createElement('img', {
                    alt: largeImage.alt,
                    className: imageClassName,
                    src: largeImage.src,
                    srcSet: largeImage.srcSet,
                    sizes: largeImage.sizes,
                    style: compositeImageStyle,
                    onLoad: onLoad,
                    onError: onError
                })
            );

            if (isLazyLoaded) {
                return isVisible ? component : null;
            }

            return component;
        }
    }]);

    return _class;
}(React.Component);

_class.displayName = 'EnlargedImage';
_class.defaultProps = {
    fadeDurationInMs: 0,
    isLazyLoaded: true
};
_class.propTypes = {
    containerClassName: PropTypes.string,
    containerStyle: PropTypes.object,
    cursorOffset: Point,
    position: Point,
    fadeDurationInMs: PropTypes.number,
    imageClassName: PropTypes.string,
    imageStyle: PropTypes.object,
    isActive: PropTypes.bool,
    isLazyLoaded: PropTypes.bool,
    largeImage: ImageShape,
    smallImage: ImageShape,
    imagePosition: PropTypes.oneOf([ENLARGED_IMAGE_POSITION.beside, ENLARGED_IMAGE_POSITION.over])
};
export default _class;