'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getLensCursorOffset = getLensCursorOffset;

var _imageRatio = require('./imageRatio');

function getLensCursorOffset(smallImage, largeImage) {
    var ratio = (0, _imageRatio.getLargeToSmallImageRatio)(smallImage, largeImage);
    return {
        x: getLensCursorOffsetDimension(smallImage.width, ratio.x),
        y: getLensCursorOffsetDimension(smallImage.height, ratio.y)
    };
}

function getLensCursorOffsetDimension(smallImageDimension, ratio) {
    return Math.round(smallImageDimension * ratio / 2);
}